import random

# write a function to generate a list of random elements
# in the range 0-1000, of a given length
def randList(l):
  lst = []
  for i in range(l):
    lst.append(random.randint(0,1000))
  return lst

# should return a list of [0..l-1]
def sortedList(l):
  return list(range(0,l))

# test whether the list is sorted
# by sorted we mean
# every item in the list is smaller (or equal)
# to things that come later in the list
def isSorted(lst):
  sorted = True
  for i in range(len(lst)):
    # loop over all elements that come after i
    # if any of them is < lst[i], set sorted = False
    for j in range(i+1,len(lst)):
      if lst[j] < lst[i]:
        sorted = False
  return sorted

def swap(lst,i,j):
  # should swap the values in the ith and jth place
  # need a temporary value to hold one of the items
  # while you're switching them
  tmp = lst[i]
  lst[i] = lst[j]
  lst[j] = tmp

# insertion sort starts at the beginning of the list
# and then for each element looks back *behind* that element and continues swapping it into place until it is bigger than all the elements behind
# it in the list
def insertionSort(lst):
  numSwaps = 0
  numComparisons = 0
  for i in range(1,len(lst)): # I think we actually 
    # this sort still involves an inner and an outer loop
    # but the inner loop here is a while loop instead of a for-loop
    j = i # here we set the index for what we'll be looking at
    # here we're always going to do at least one comparison
    numComparisons = numComparisons + 1
    while (lst[j-1] > lst[j]) and j > 0: # we can't go backwards anymore if j = 0 and we don't *want* to go backwards if lst[j-1] <= lst[j]
      swap(lst,j-1,j)
      numSwaps = numSwaps+1
      j = j - 1 # step backwards
      if j > 0:
        numComparisons = numComparisons + 1 # this is here because we're going to do another comparison at the start of the while loop
  print(f"The number of comparisons is {numComparisons}")
  print(f"The number of swaps done is {numSwaps}")