import random

# write a function to generate a list of random elements
# in the range 0-1000, of a given length
def randList(l):
  lst = []
  for i in range(l):
    lst.append(random.randint(0,1000))
  return lst

# should return a list of [0..l-1]
def sortedList(l):
  return list(range(0,l))

# test whether the list is sorted
# by sorted we mean
# every item in the list is smaller (or equal)
# to things that come later in the list
def isSorted(lst):
  sorted = True
  for i in range(len(lst)):
    # loop over all elements that come after i
    # if any of them is < lst[i], set sorted = False
    for j in range(i+1,len(lst)):
      if lst[j] < lst[i]:
        sorted = False
  return sorted

def swap(lst,i,j):
  # should swap the values in the ith and jth place
  # need a temporary value to hold one of the items
  # while you're switching them
  tmp = lst[i]
  lst[i] = lst[j]
  lst[j] = tmp

# selection sort starts at the left-hand side
# searches for the smallest element and swaps it for
# the current starting place then moves ahead one space
# and repeats the process
def selection(lst):
  numSwaps = 0
  numComparisons = 0
  for i in range(len(lst)):
    smallestIndex = i
    # inner loop to find smallestIndex
    for j in range(i+1,len(lst)):
      numComparisons = numComparisons + 1
      if lst[j] < lst[smallestIndex]:
        smallestIndex = j
    # now we assume smallestIndex is set correctly
    if i != smallestIndex:   
      swap(lst,i,smallestIndex)
      numSwaps = numSwaps + 1
  # sorting done, let's print stats
  print(f"The num of swaps: {numSwaps}")
  print(f"The num of comparisons: {numComparisons}")